define(function(require, exports, module) {
	require("./ajaxfileupload");
	var layerUtils = require("layerUtils");
	(function(window, $, undefined) {
		  $.support.filereader = !!(window.File && window.FileReader && window.FileList && window.Blob);
		  var setting = {
				  type:"POST",
				  secureuri:true,
				  dataType:"json",
				  data:{},
				  immediate:false,
				  maxsize:false,
				  minsize:false,
			      success: null,
			      error: null
			  };
		  $.fn.uploadVideo = function(options) {
			    var opts = {};
		        $.extend(opts, setting, options);
		        var $self = this;
		        if (!$.support.filereader) {
		    	  if($.isFunction(opts.error)) {
	                   opts.error.apply(self, [{},1,'\u4E0D\u652F\u6301\u4E0A\u4F20\u529F\u80FD']);
	               }
		    	  return ;
		        }
		        $self.change(function() {
		        	var self = this;
		            var files = self.files;
//					var lastModified = files[0].lastModified;
//					var currentTime = new Date().getTime();
//					if(currentTime - lastModified > 100){
//						layerUtils.iAlert("不能选择相册文件，请重新拍照上传！",-1);
//						return false;
//					}
		            if (!files.length) return ;
		            var file = files[0];
		            var fr = new FileReader();
		            var mime = {'mp4': 'video/mp4', 'avi': 'video/avi','3gp': 'video/3gp','flv': 'video/flv','m4v': 'video/m4v','divx': 'video/divx','mov': 'video/mov','mpeg': 'video/mpeg','mpg': 'video/mpg','ogm': 'video/ogm','ogv': 'video/ogv','ogx': 'video/ogx','rm': 'video/rm','rmvb': 'video/rmvb','smil': 'video/smil','wmv': 'video/wmv','webm': 'video/webm'};
		            var filtermine = {'video/mp4':'mp4', 'video/avi':'avi','video/3gp':'3gp','video/flv':'flv'}
		            var fileType= file.type;
		            if (!fileType) 
					{
						fileType = mime[file.name.match(/\.([^\.]+)$/i)[1]];
					}
		            if (fileType)
		            {
//		            	if(!filtermine[fileType]){
//		            		if ($.isFunction(opts.error)) {
//			                    opts.error.apply(self, [{},9,'\u6587\u4EF6\u683C\u5F0F\u9519\u8BEF']);
//			                }
//		            		return ;
//		            	}
		            	
		            }
		            if(opts.immediate && file.lastModifiedDate){
		            	if(typeof(file.lastModifiedDate)=="object" && (file.lastModifiedDate instanceof Date))
		            	{
		            		 var current_time = new Date().getTime();
		            		 var click_time = $(self).attr("currenttime");
		            		 var file_time = file.lastModifiedDate.getTime();
		            		 if(click_time>file_time+2000 || current_time<file_time-1000){
		            			 if ($.isFunction(opts.error)) {
					                    opts.error.apply(self, [{},10,'\u8BF7\u5F55\u50CF\u4E0A\u4F20\u89C6\u9891']);
					                    return false;
					               }
		            		 }
		            	}
		            }
		            if(opts.maxsize){
		            	if(file.size>opts.maxsize*1024){
		            		if ($.isFunction(opts.error)) {
			                    opts.error.apply(self, [{},6,'\u4E0A\u4F20\u6587\u4EF6\u592A\u5927']);
			                    return false;
			               }
		            	}
		            }
		            if(opts.minsize){
		            	if(file.size<opts.minsize*1024){
		            		if ($.isFunction(opts.error)) {
			                    opts.error.apply(self, [{},7,'\u4E0A\u4F20\u6587\u4EF6\u592A\u5927']);
			                    return false;
			               }
		            	}
		            }
		            if ($.isFunction(opts.before)) {
	                    opts.before.apply(self, []);
	                }else{
	                	require("layerUtils").iLoading(true,"正在上传中...");  // 显示等待层
	                }
		            var callback = function(data){
			            if(window.FormData) //support http5 formdata upload 
		            	{ 
		            		var xhr = new XMLHttpRequest();
		    		        var data = new FormData();
		    		        xhr.onreadystatechange = function() {
		    		            if (xhr.readyState === 4) {
		    		                if(xhr.status == "200")
		    		                {
		    		                	var data  = opts.dataType == "xml"  ? xhr.responseXML : xhr.responseText;
		    		                	if ( opts.dataType == "script" ) {
		    		         	            $.globalEval( data );
		    		                    }else if ( opts.dataType == "json" ){
		    		                		eval("data = " + data );
		    		                	}else if ( opts.dataType == "html" ){
		    		                		 $("<div>").html(data).evalScripts();
		    		                	}
		    		                	if ($.isFunction(opts.success)) {
						                    opts.success.apply(self,[data,0]);
						                }
		    		                }else 
		    		                {
		    		                	if ($.isFunction(opts.error)) {
						                    opts.error.apply(self, [xhr,-1,""]);
						                }
		    		                }
		    		            }
		    		        };
		    		        data.append("file", file);
		    		        xhr.open("post", opts.url, true);
		    		        xhr.setRequestHeader("Content-Disposition", 'multipart/form-data');
		    		        xhr.send(data);
							window.closeUpload = function(){
								xhr && xhr.abort();
							}
		            	}else{
		            		$.ajaxFileUpload({  
				                url: opts.url,
				                secureuri:opts.secureuri,  
				                type:opts.type,
				                data:opts.data,
				                dataType:opts.dataType,
				                fileElementId:opts.fileElementId,                                 //文件选择框的id属性  
				                success: function (obj, status){
				                	if ($.isFunction(opts.success)) {
					                    opts.success.apply(self, [obj,status]);
					                }else{
					                	
					                }
				                },error: function (obj, status, e){  
				                	if ($.isFunction(opts.error)) {
					                    opts.error.apply(self, [obj,-1,e]);
					                }
				                	
				                }
				            });
		            	}
		            }
		        	if ($.isFunction(opts.change)) {
		        		opts.change.apply(self, [callback]);
		        	}else{
		        		callback();
		        	}
		            if ($.isFunction(opts.after)) {
	                    opts.after.apply(self, []);
	                }
		        });
		  }
		  
	})(window, jQuery);
});